#!/bin/bash

IMF="-fimf-domain-exclusion=15 -fimf-accuracy-bits=12"
OPT="-O3 -no-prec-div -ansi-alias $IMF"
NTH=228

if [ "x$1" != "x-f" ]; then
  icpc $OPT -mmic -openmp nbody.cpp -lpthread -o nbody
else
  ifort -fpp $OPT -mmic -openmp nbody.f90 -lpthread -o nbody
  NTH=
fi

SINK_LD_LIBRARY_PATH=$MKLROOT/../compiler/lib/mic \
  /opt/intel/mic/bin/micnativeloadex nbody \
  -e "KMP_AFFINITY=balanced" \
  -a "262144 $NTH" \
  -d 0
