@ECHO OFF
SETLOCAL

SET IMF=-imf-domain-exclusion=15 -imf-accuracy-bits=12
SET WMF=/Qimf-domain-exclusion:15 /Qimf-accuracy-bits:12
SET OPT=-O3 -Qno-prec-div -Qansi-alias %WMF%
SET NTH=32

IF NOT "%1" == "-f" (
  icl %OPT% -QxHost -Qopenmp -Qopt-report-phase:offload -Qopenmp-report -Qoffload-option,mic,compiler,"%IMF%" nbody.cpp -o nbody.exe
) ELSE (
  ifort -fpp %OPT% -QxHost -Qopenmp -Qopt-report-phase:offload -Qopenmp-report -Qoffload-option,mic,compiler,"%IMF%" nbody.f90 -o nbody.exe
  SET NTH=
)

nbody 262144 %NTH%

ENDLOCAL