#!/bin/bash

IMF="-fimf-domain-exclusion=15 -fimf-accuracy-bits=12"
OPT="-O3 -no-prec-div -ansi-alias $IMF"
NTH=224

if [ "x$1" != "x-f" ]; then
  icpc $OPT -xHost -openmp -opt-report-phase offload -openmp-report -offload-option,mic,compiler,"$IMF" nbody.cpp -lpthread -o nbody
else
  ifort -fpp $OPT -xHost -openmp -opt-report-phase offload -openmp-report -offload-option,mic,compiler,"$IMF" nbody.f90 -lpthread -o nbody
  NTH=
fi

./nbody 262144 $NTH
