@ECHO OFF
SETLOCAL

SET IMF=-Qimf-domain-exclusion=15 -Qimf-accuracy-bits=12
SET OPT=-O3 -Qno-prec-div -Qansi-alias %IMF%

IF NOT "%1" == "-f" (
  icl %OPT% -QxHost -Qopenmp nbody.cpp -o nbody.exe
) ELSE (
  ifort -fpp %OPT% -QxHost -Qopenmp nbody.f90 -o nbody.exe
)

nbody 262144

ENDLOCAL