#!/bin/bash

IMF="-fimf-domain-exclusion=15 -fimf-accuracy-bits=12"
OPT="-O3 -no-prec-div -ansi-alias -complex-limited-range $IMF"

icc -std=c99 $OPT -mmic -openmp main.c mandel.c -o mandel.exe

SINK_LD_LIBRARY_PATH=$MKLROOT/../compiler/lib/mic \
  /opt/intel/mic/bin/micnativeloadex mandel.exe \
  -e "KMP_AFFINITY=balanced" \
  -d 0
